# TODO
# - fcgi subpackage
Summary:	Browser interface for CVS and Subversion version control repositories
Summary(pl.UTF-8):	Interfejs przeglądarki do repozytoriów systemów kontroli wersji CVS i Subversion
Name:		viewvc
Version:	1.1.23
Release:	1
License:	BSD
Group:		Applications/WWW
Source0:	http://viewvc.tigris.org/files/documents/3330/49392/%{name}-%{version}.tar.gz
# Source0-md5:	796aacdfcd8ab87a196d97df2691cd3f
Source1:	apache.conf
URL:		http://viewvc.org/
BuildRequires:	python
BuildRequires:	python-modules
BuildRequires:	rpm-pythonprov
BuildRequires:	rpmbuild(macros) >= 1.268
Requires:	%{name}-template
Requires:	webapps
Suggests:	cvsgraph >= 1.5.0
Suggests:	python-MySQLdb >= 0.9.0
Suggests:	python-pygments >= 0.9
Obsoletes:	viewcvs
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_webapps	/etc/webapps
%define		_webapp		%{name}
%define		_sysconfdir	%{_webapps}/%{_webapp}
%define		_appdir		%{_datadir}/%{_webapp}

%description
ViewVC is a browser interface for CVS and Subversion version control
repositories. It generates templatized HTML to present navigable
directory, revision, and change log listings. It can display specific
versions of files as well as diffs between those versions. Basically,
ViewVC provides the bulk of the report-like functionality you expect
out of your version control tool, but much more prettily than the
average textual command-line program output.

Here are some of the additional features of ViewVC:
- Support for filesystem-accessible CVS and Subversion repositories.
- Individually configurable virtual host support.
- Line-based annotation/blame display.
- Revision graph capabilities (via integration with CvsGraph) (CVS
  only).
- Syntax highlighting support (via integration with GNU enscript or
  Highlight).
- Bonsai-like repository query facilities.
- Template-driven output generation.
- Colorized, side-by-side differences.
- Tarball generation (by tag/branch for CVS, by revision for
  Subversion).
- I18N support based on the Accept-Language request header.
- Ability to run either as CGI script or as a standalone server.
- Regexp-based file searching.
- INI-like configuration file (as opposed to requiring actual code
  tweaks).

In order to run viewvc you must install viewvc-cgi or
viewvc-mod_python package.

%description -l pl.UTF-8
ViewVC to interfejs przeglądarki do repozytoriów systemów kontroli
wersji CVS i Subversion. Generuje oparty o szablony HTML prezentujący
listingi katalogów, rewizji i historii zmian z możliwością nawigacji.
Może wyświetlać określone wersje plików oraz różnice między wersjami.
Zasadniczo ViewVC udostępnia sporą funkcjonalność generowania
raportów, jakiej można by oczekiwać od narzędzi do kontroli wersji,
ale daje ona dużo ładniejsze wyniki niż w przypadku narzędzi
działających z linii poleceń.

Niektóre dodatkowe możliwości ViewVC:
- obsługa repozytoriów CVS i Subversion dostępnych w systemie plików
- oddzielnie konfigurowalna obsługa wirtualnych hostów
- liniowe wyświetlanie przypisów/autorów ostatnich zmian
- możliwość rysowania wykresów rewizji (poprzez integrację z
  cvsgraphem - tylko CVS)
- obsługa podświetlania składni (poprzez integrację z GNU enscriptem
  lub Highlightem)
- uproszczenie zapytań w stylu Bonsai
- generowanie wyjścia w oparciu o szablony
- kolorowe, dwustronne różnice
- generowanie tarballi (po tagu/branchu w CVS-ie, po rewizji w
  Subversion)
- obsługa I18N w oparciu o nagłówek żądania Accept-Language
- możliwość uruchamiania jako skrypt CGI i samodzielny serwer
- wyszukiwanie plików w oparciu o wyrażenia regularne
- plik konfiguracyjny w stylu INI (nie wymagający modyfikacji kodu).

Aby uruchomić viewvc należy zainstalować pakiet viewvc-cgi lub
viewvc-mod_python.

%package cgi
Summary:	ViewVC - CGI interface
Summary(pl.UTF-8):	ViewVC - interfejs CGI
Group:		Applications/WWW
Requires:	%{name} = %{version}-%{release}
Requires:	webserver(cgi)

%description cgi
ViewVC - CGI interface.

%description cgi -l pl.UTF-8
ViewVC - interfejs CGI.

%package mod_python
Summary:	ViewVC - mod_python interface
Summary(pl.UTF-8):	ViewVC - interfejs mod_python
Group:		Applications/WWW
Requires:	%{name} = %{version}-%{release}
Requires:	apache-mod_python
Requires:	python-subversion

%description mod_python
ViewVC - mod_python interface.

%description mod_python -l pl.UTF-8
ViewVC - interfejs mod_python.

%package template-default
Summary:	ViewVC - default template
Summary(pl.UTF-8):	ViewVC - domyślny szablon
Group:		Applications/WWW
Requires:	%{name} = %{version}-%{release}
Requires:	webserver(cgi)
Provides:	%{name}-template

%description template-default
ViewVC - default template

%description template-default -l pl.UTF-8
ViewVC - domyślny szablon

%package template-newvc
Summary:	ViewVC - newvc template
Summary(pl.UTF-8):	ViewVC - szablon newvc
Group:		Applications/WWW
Requires:	%{name} = %{version}-%{release}
Requires:	webserver(cgi)
Provides:	%{name}-template

%description template-newvc
ViewVC - newvc template

%description template-newvc -l pl.UTF-8
ViewVC - szablon newvc


%package template-viewsvn
Summary:	ViewVC - viewsvn template
Summary(pl.UTF-8):	ViewVC - szablon viewsvn
Group:		Applications/WWW
Requires:	%{name} = %{version}-%{release}
Requires:	webserver(cgi)
Provides:	%{name}-template

%description template-viewsvn
ViewVC - viewsvn template

%description template-viewsvn -l pl.UTF-8
ViewVC - szablon viewsvn

%prep
%setup -q

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_appdir}}

cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/apache.conf
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/httpd.conf
#cp -p lighttpd.conf $RPM_BUILD_ROOT%{_sysconfdir}/lighttpd.conf

./viewvc-install \
	--prefix=%{_appdir} \
	--destdir=$RPM_BUILD_ROOT

mv  $RPM_BUILD_ROOT{%{_appdir},%{_sysconfdir}}/cvsgraph.conf
mv $RPM_BUILD_ROOT{%{_appdir},%{_sysconfdir}}/viewvc.conf
ln -s %{_sysconfdir}/cvsgraph.conf $RPM_BUILD_ROOT%{_appdir}/cvsgraph.conf
ln -s %{_sysconfdir}/viewvc.conf $RPM_BUILD_ROOT%{_appdir}/viewvc.conf

%py_postclean %{_appdir}/lib

# cleanup
rm $RPM_BUILD_ROOT%{_appdir}/lib/win32popen.pyc
rm $RPM_BUILD_ROOT%{_appdir}/cvsgraph.conf.dist
rm $RPM_BUILD_ROOT%{_appdir}/mimetypes.conf.dist
rm $RPM_BUILD_ROOT%{_appdir}/viewvc.conf.dist
rm -r $RPM_BUILD_ROOT%{_appdir}/lib/vclib/ccvs/rcsparse/test-data

%clean
rm -rf $RPM_BUILD_ROOT

%triggerpostun -- %{name} < 1.1.23-1
# skip on downgrade
[ $1 -le 1 ] && exit 0

for f in cvsgraph.conf viewvc.conf; do
	test -f /etc/viewvc/$f.rpmsave || continue
	cp -f %{_sysconfdir}/$f{,.rpmnew}
	mv -vf /etc/viewvc/$f.rpmsave %{_sysconfdir}/$f
done

# ensure safe exit even if above move failed
exit 0

%triggerin -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{_webapp}

%triggerun -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{_webapp}

%triggerin -- apache < 2.2.0, apache-base
%webapp_register httpd %{_webapp}

%triggerun -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{_webapp}

%if 0
%triggerin -- lighttpd
%webapp_register lighttpd %{_webapp}

%triggerun -- lighttpd
%webapp_unregister lighttpd %{_webapp}
%endif

%files
%defattr(644,root,root,755)
%doc CHANGES COMMITTERS INSTALL
%dir %attr(755,root,http) %{_sysconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/apache.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/httpd.conf
#%%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/lighttpd.conf
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/cvsgraph.conf
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/viewvc.conf
%dir %{_appdir}
%dir %{_appdir}/bin
%attr(755,root,root) %{_appdir}/bin/standalone.py
%attr(755,root,root) %{_appdir}/bin/loginfo-handler
%attr(755,root,root) %{_appdir}/bin/cvsdbadmin
%attr(755,root,root) %{_appdir}/bin/svndbadmin
%attr(755,root,root) %{_appdir}/bin/make-database
%{_appdir}/viewvc.conf
%{_appdir}/cvsgraph.conf
%dir %{_appdir}/lib
%{_appdir}/lib/PyFontify.py[co]
%{_appdir}/lib/accept.py[co]
%{_appdir}/lib/blame.py[co]
%{_appdir}/lib/compat.py[co]
%{_appdir}/lib/compat_difflib.py[co]
%{_appdir}/lib/compat_ndiff.py[co]
%{_appdir}/lib/config.py[co]
%{_appdir}/lib/cvsdb.py[co]
%{_appdir}/lib/dbi.py[co]
%{_appdir}/lib/debug.py[co]
%{_appdir}/lib/ezt.py[co]
%{_appdir}/lib/idiff.py[co]
%{_appdir}/lib/popen.py[co]
%{_appdir}/lib/py2html.py[co]
%{_appdir}/lib/query.py[co]
%{_appdir}/lib/sapi.py[co]
%dir %{_appdir}/lib/vcauth
%dir %{_appdir}/lib/vcauth/forbidden
%dir %{_appdir}/lib/vcauth/forbiddenre
%dir %{_appdir}/lib/vcauth/svnauthz
%{_appdir}/lib/vcauth/__init__.py[co]
%{_appdir}/lib/vcauth/forbidden/__init__.py[co]
%{_appdir}/lib/vcauth/forbiddenre/__init__.py[co]
%{_appdir}/lib/vcauth/svnauthz/__init__.py[co]
%dir %{_appdir}/lib/vclib
%{_appdir}/lib/vclib/__init__.py[co]
%dir %{_appdir}/lib/vclib/ccvs
%{_appdir}/lib/vclib/ccvs/__init__.py[co]
%{_appdir}/lib/vclib/ccvs/blame.py[co]
%{_appdir}/lib/vclib/ccvs/bincvs.py[co]
%{_appdir}/lib/vclib/ccvs/ccvs.py[co]
%{_appdir}/lib/vclib/ccvs/rcsparse/parse_rcs_file.py[co]
%{_appdir}/lib/vclib/ccvs/rcsparse/run-tests.py[co]
%dir %{_appdir}/lib/vclib/ccvs/rcsparse
%{_appdir}/lib/vclib/ccvs/rcsparse/__init__.py[co]
%{_appdir}/lib/vclib/ccvs/rcsparse/common.py[co]
%{_appdir}/lib/vclib/ccvs/rcsparse/debug.py[co]
%{_appdir}/lib/vclib/ccvs/rcsparse/default.py[co]
%{_appdir}/lib/vclib/ccvs/rcsparse/texttools.py[co]
%dir %{_appdir}/lib/vclib/svn
%{_appdir}/lib/vclib/svn/__init__.py[co]
%{_appdir}/lib/vclib/svn/svn_ra.py[co]
%{_appdir}/lib/vclib/svn/svn_repos.py[co]
%{_appdir}/lib/viewvc.py[co]
%{_appdir}/mimetypes.conf
%dir %{_appdir}/templates
%dir %{_appdir}/templates-contrib
%{_appdir}/templates-contrib/README

%files cgi
%defattr(644,root,root,755)
%dir %{_appdir}/bin/cgi
%attr(755,root,root) %{_appdir}/bin/cgi/viewvc.cgi
%attr(755,root,root) %{_appdir}/bin/cgi/query.cgi

%files mod_python
%defattr(644,root,root,755)
%dir %{_appdir}/bin/mod_python
%attr(640,root,http) %config(noreplace) %verify(not md5 mtime size) %{_appdir}/bin/mod_python/.htaccess
%{_appdir}/bin/mod_python/viewvc.py
%{_appdir}/bin/mod_python/query.py
%{_appdir}/bin/mod_python/handler.py

%files template-default
%defattr(644,root,root,755)
%{_appdir}/templates/

%files template-newvc
%defattr(644,root,root,755)
%{_appdir}/templates-contrib/newvc/

%files template-viewsvn
%defattr(644,root,root,755)
%{_appdir}/templates-contrib/viewsvn/
%changelog
* Thu May 14 2015 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/viewvc.git;a=log;h=AC-branch

* Wed May 13 2015 Elan Ruusamäe <glen@delfi.ee> 00bf181
- fill optional dependencies

* Wed May 13 2015 Elan Ruusamäe <glen@delfi.ee> 6e8a803
- adapter

* Wed May 13 2015 Elan Ruusamäe <glen@delfi.ee> a326e90
- move config to webapps dir

* Wed May 13 2015 Elan Ruusamäe <glen@delfi.ee> 2194f21
- up to Version 1.1.23 (released 04-Nov-2014)

* Wed May 13 2015 Elan Ruusamäe <glen@delfi.ee> 60aacd5
- apache conf compatible with apache 1.3-2.4

* Wed May 13 2015 Elan Ruusamäe <glen@delfi.ee> e0acb70
- Revert "- migrated to apache 2.4"

* Fri May 17 2013 Jan Rękorajski <baggins@pld-linux.org> 1805023
- migrated to apache 2.4

* Mon Mar 07 2011 areq <areq@pld-linux.org> 0d0d25d
- 1.1.9

* Wed Dec 15 2010 Elan Ruusamäe <glen@pld-linux.org> b8e9cc1
- webapps done wrong (or partially)

* Wed Dec 15 2010 shadzik <shadzik@pld-linux.org> c2ea141
- 1

* Wed Dec 15 2010 Elan Ruusamäe <glen@pld-linux.org> 9fe4aed
- todo in spec header, or it won't be 'visible' for other devs

* Wed Dec 15 2010 shadzik <shadzik@pld-linux.org> 66e742c
- 1.1.8
- TODO: fcgi subpackage

* Thu Oct 14 2010 areq <areq@pld-linux.org> 9dfe28e
- 1.1.7

* Sun Jun 06 2010 shadzik <shadzik@pld-linux.org> 0dc3f82
- R: python-subversion

* Sun Jun 06 2010 shadzik <shadzik@pld-linux.org> b5c3fbd
- 1.1.6

* Mon May 24 2010 Elan Ruusamäe <glen@pld-linux.org> 0d0e33b
- cleanup

* Fri May 14 2010 sparky <sparky@pld-linux.org> cdd57a6
- BR: python, rpm-pythonprov

* Fri Apr 30 2010 Andrzej Zawadzki <zawadaa@gmail.com> 59d1bb6
- up to 1.1.5 security fix: - XSS attack
- ci forgotten http config file

* Thu Mar 18 2010 Andrzej Zawadzki <zawadaa@gmail.com> 587ec05
- up to 1.1.4
- security fix: escape user-provided query form input to avoid XSS attack.

* Fri Dec 18 2009 matik <matik@pld-linux.org> 5de7a71
- moved templates to separate packages
- adapterized
- more files packaged
- httpd config moved to separate file

